       subroutine eigen_hrd_u(
     &              ar,ai,
     &              ur_x,ui_x,
     &              ur_y,ui_y,
     &              u_t,v_t,
     &              x_root,y_root,x_pos,
     &              n,nm,nv
#ifdef MEMORY1
! wr > ar, wi > ai
     &            ,nxx_ar,nxx_ai
     &            ,nxx_ur_x,nxx_ui_x
     &            ,nxx_ur_y,nxx_ui_y
     &            ,nxx_u_t,nxx_v_t
#endif
     &            )
!
      use communication_h, only : send_dbl
     &               , recv_dbl
     &               , reduce_dbl
     &               , bcast_dbl
     &               , datacast_dbl
!
      implicit none

      integer, intent(in)    :: nm, nv, n
      real(8), intent(in)    :: ar(1:nm)
      real(8), intent(in)    :: ai(1:nm)
      real(8), intent(inout) :: ur_x(1:nv), ur_y(1:nv)
      real(8), intent(inout) :: ui_x(1:nv), ui_y(1:nv)
      real(8), intent(inout) :: u_t(1:nv+4), v_t(1:nv+4)

      integer ::  j_1, j_2, j_3
      integer ::  x_root, x_pos
      integer ::  y_root

!...  real(8) ::  scale, theta
      real(8) ::  scale(1), theta(1)
      real(8) ::  alpha, beta, gamma(2), kappa(2)
      real(8) ::  wk1(3), wk2(3)

      include 'trd.h'
#ifdef MEMORY1
      integer,intent(in) :: nxx_ar
      integer,intent(in) :: nxx_ai
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_u_t
      integer,intent(in) :: nxx_v_t
#endif
#ifdef MEMORY1
      integer :: nxx
#endif


      j_2 = 1
      j_3 = n
!
! u=...
!
!     print*,"eigen_hrd_u start"
      if(y_root==my_row)then
         scale(1) = 0.0d+00
#ifdef MEMORY1
      nxx = xx_ar(5000,j_3)
      nxx = xx_ai(5010,j_3)
#endif
         do j_1=j_2,j_3
            scale(1) = scale(1)+abs(ar(j_1))+abs(ai(j_1))
         enddo! j_1
         call reduce_dbl(scale, theta, 1, mpi_comm_col)
         if(scale(1)/=0.0d+00)then
            alpha    = 0.0d+00
            gamma(1) = 0.0d+00
            gamma(2) = 0.0d+00
#ifdef MEMORY1
      nxx = xx_ar (5020,j_3)
      nxx = xx_ai (5030,j_3)
      nxx = xx_u_t(5040,j_3)
      nxx = xx_v_t(5050,j_3)
#endif
            do j_1=j_2,j_3
               u_t(j_1) = ar(j_1)/scale(1)
               v_t(j_1) = ai(j_1)/scale(1)
               alpha     = alpha+u_t(j_1)**2+v_t(j_1)**2
            enddo! j_1
            if(x_root==my_col)then
#ifdef MEMORY1
      nxx = xx_u_t (5060,x_pos)
      nxx = xx_v_t (5070,x_pos)
#endif
               gamma(1) = u_t(x_pos)
               gamma(2) = v_t(x_pos)
            endif
            wk1(1) = gamma(1)
            wk1(2) = gamma(2)
            wk1(3) = alpha
            call reduce_dbl(wk1, wk2, 3, mpi_comm_col)
            gamma(1) = wk1(1)
            gamma(2) = wk1(2)
            alpha    = wk1(3)
         endif
#ifdef MEMORY1
      nxx = xx_u_t (5080,x_pos+3)
      nxx = xx_v_t (5090,x_pos+3)
#endif
         u_t(x_pos+1) = scale(1)
         u_t(x_pos+2) = alpha
         u_t(x_pos+3) = gamma(1)
         v_t(x_pos+3) = gamma(2)
      endif
!
      if ( nprocs >= es_cluster**2 .and.
     &       size_of_col > 1 .and. es_icnod > 1 ) then
         call recv_dbl(u_t(1), 0, es_icnod-1, es_ccomm_world)
      endif
#ifdef MEMORY1
      nxx = xx_u_t(5100,x_pos+3)
      nxx = xx_v_t(5110,x_pos+3)
#endif
      call bcast_dbl(u_t(1), x_pos+3, y_root, mpi_comm_row)
      call bcast_dbl(v_t(1), x_pos+3, y_root, mpi_comm_row)
      if ( nprocs >= es_cluster**2 .and.
     &       size_of_col > 1 .and. es_icnod < es_ncnod ) then
         call send_dbl(u_t(1), 0, es_icnod+1, es_ccomm_world)
      endif
!
#ifdef MEMORY1
      nxx = xx_u_t(5120,x_pos+1)
#endif
      scale(1)=u_t(x_pos+1)
      if(scale(1)/=0.0d+00)then
         alpha = u_t(x_pos+2)
#ifdef MEMORY1
      nxx = xx_u_t(5130,x_pos+3)
      nxx = xx_v_t(5140,x_pos+3)
#endif
         gamma(1) = u_t(x_pos+3)
         gamma(2) = v_t(x_pos+3)
         theta(1) = sqrt(alpha)
         kappa(1) = sqrt(u_t(x_pos+3)**2+v_t(x_pos+3)**2)
         ur_x(j_2:j_3) = u_t(j_2:j_3)
         ui_x(j_2:j_3) = v_t(j_2:j_3)
         if(x_root==my_col)then
#ifdef MEMORY1
      nxx = xx_ur_x(5150,j_3)
      nxx = xx_ui_x(5160,j_3)
      nxx = xx_u_t (5170,j_3)
      nxx = xx_v_t (5180,j_3)
#endif
            if(kappa(1)/=0.0d+00)then
               kappa(2) = 1.0d+00+theta(1)/kappa(1)
            else
               kappa(2) = 1.0d+00
            endif
            ur_x(x_pos) = kappa(2)*ur_x(x_pos)
            ui_x(x_pos) = kappa(2)*ui_x(x_pos)
         endif
#ifdef MEMORY1
      nxx = xx_ur_y(5190,x_pos)
      nxx = xx_ur_x(5200,x_pos)
      nxx = xx_u_t (5210,x_pos)
      nxx = xx_v_t (5220,x_pos)
      nxx = xx_ui_y(5230,x_pos)
      nxx = xx_ui_x(5240,x_pos)
#endif
         call datacast_dbl(ur_y,ur_x, u_t,v_t, x_pos)
         call datacast_dbl(ui_y,ui_x, u_t,v_t, x_pos)
         beta = alpha+kappa(1)*theta(1)
         if(x_root==my_col)then
            u_t(x_pos  ) = ur_x(x_pos  )
            v_t(x_pos  ) = ui_x(x_pos  )
         endif
#ifdef MEMORY1
      nxx = xx_v_t(5250,x_pos+4)
      nxx = xx_u_t(5260,x_pos+4)
#endif
         v_t(x_pos+1) = gamma(1)
         v_t(x_pos+2) = gamma(2)
         v_t(x_pos+3) = kappa(1)
         v_t(x_pos+4) = kappa(2)
         u_t(x_pos+1) = scale(1)
         u_t(x_pos+2) = alpha
         u_t(x_pos+3) = theta(1)
         u_t(x_pos+4) = beta
      endif
!     print*,"eigen_hrd_u passed"

      return
#ifdef MEMORY1
      contains

      function xx_ar(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ar
      integer :: i0,i1
      xx_ar = nxx_ar + i1 - 1
      call accessor(i0,xx_ar,kxx_ar,"eigen_hrd_u:ar")
      end function

      function xx_ai(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ai
      integer :: i0,i1
      xx_ai = nxx_ai + i1 - 1
      call accessor(i0,xx_ai,kxx_ai,"eigen_hrd_u:ai")
      end function

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"eigen_hrd_u:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"eigen_hrd_u:ui_x")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"eigen_hrd_u:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"eigen_hrd_u:ui_y")
      end function

      function xx_u_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_u_t
      integer :: i0,i1
      xx_u_t = nxx_u_t + i1 - 1
      call accessor(i0,xx_u_t,kxx_u_t,"eigen_hrd_u:u_t")
      end function

      function xx_v_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_v_t
      integer :: i0,i1
      xx_v_t = nxx_v_t + i1 - 1
      call accessor(i0,xx_v_t,kxx_v_t,"eigen_hrd_u:v_t")
      end function
#endif
      end subroutine
