      subroutine eigen_hrd_v(
     &             ur_x,ui_x, vr_x,vi_x, vr_y,vi_y,
     &             u_t,v_t,
     &             beta, n,x_pos,nv
#ifdef MEMORY1
! ur_t > u_t, vr_t > v_t
     &             ,nxx_ur_x,nxx_ui_x
     &             ,nxx_vr_x,nxx_vi_x
     &             ,nxx_vr_y,nxx_vi_y
     &             ,nxx_u_t,nxx_v_t
#endif
     &           )
!----
      use communication_h, only : reduce_dbl
     &               , datacast_dbl
!----
      implicit none

      integer, intent(in)    :: n, nv
      real(8), intent(in)    :: ur_x(1:nv)
      real(8), intent(inout) :: vr_x(1:nv), vr_y(1:nv)
      real(8), intent(in)    :: ui_x(1:nv)
      real(8), intent(inout) :: vi_x(1:nv), vi_y(1:nv)
!---  real(8), intent(inout) :: u_t(1:nv),  v_t(1:nv)
      real(8), intent(inout) :: u_t(1:*),  v_t(1:*)

!---- real(8) ::  alpha, beta, gamma, theta
      real(8) ::  alpha(1), gamma(1), theta(1)
      real(8) ::  beta
      integer ::  j_1, j_2, j_3, x_pos

      real(8) ::  vr_x0, vi_x0
      real(8) ::  ur_x0, ui_x0

      include 'trd.h'
#ifdef MEMORY1
! ur_t > u_t, vr_t > v_t
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_vr_y
      integer,intent(in) :: nxx_vi_y
      integer,intent(in) :: nxx_u_t
      integer,intent(in) :: nxx_v_t
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

!----
      j_2 = 1
      j_3 = n
!----
! v':= v-((u,v)/2|u|^2)u
!----
      alpha(1) = 0.0d+00
      gamma(1) = 0.0d+00
#ifdef MEMORY1
      nxx = xx_vr_x(6000,j_3)
      nxx = xx_vi_x(6010,j_3)
#endif
      do j_1=j_2,j_3
         gamma(1) = gamma(1)+abs(vr_x(j_1))
     &                      +abs(vi_x(j_1))
      enddo! j_1
      call reduce_dbl(gamma, theta, 1, mpi_comm_col)
      if(gamma(1)/=0.0d+00)then
#ifdef MEMORY1
      nxx = xx_vr_x(6020,j_3)
      nxx = xx_vi_x(6030,j_3)
      nxx = xx_ur_x(6040,j_3)
      nxx = xx_ui_x(6050,j_3)
#endif
         do j_1=j_2,j_3
            vr_x0 = vr_x(j_1)
            vi_x0 = vi_x(j_1)
            vr_x0 = vr_x0/(gamma(1)*beta)
            vi_x0 = vi_x0/(gamma(1)*beta)
            ur_x0 = ur_x(j_1)
            ui_x0 = ui_x(j_1)
            alpha(1)     = alpha(1)+vr_x0*ur_x0
     &                             +vi_x0*ui_x0
            vr_x(j_1) = vr_x0
            vi_x(j_1) = vi_x0
         enddo! j_1
         alpha(1) = alpha(1)*gamma(1)
      endif
      call reduce_dbl(alpha, theta, 1, mpi_comm_col)
      alpha(1) = alpha(1)/(beta+beta)
#ifdef MEMORY1
      nxx = xx_vr_x(6060,j_3)
      nxx = xx_ur_x(6070,j_3)
      nxx = xx_vi_x(6080,j_3)
      nxx = xx_ui_x(6090,j_3)
#endif
      do j_1=j_2,j_3
         vr_x0 = vr_x(j_1)
         ur_x0 = ur_x(j_1)
         vi_x0 = vi_x(j_1)
         ui_x0 = ui_x(j_1)
         vr_x0 = gamma(1)*vr_x0-alpha(1)*ur_x0
         vi_x0 = gamma(1)*vi_x0-alpha(1)*ui_x0
         vr_x(j_1) = vr_x0
         vi_x(j_1) = vi_x0
      enddo! j_1
#ifdef MEMORY1
      nxx = xx_vr_y(6100,x_pos)
      nxx = xx_vr_x(6110,x_pos)
      nxx = xx_u_t (6120,x_pos)
      nxx = xx_v_t (6130,x_pos)
      nxx = xx_vi_y(6140,x_pos)
      nxx = xx_vi_x(6150,x_pos)
#endif
      call datacast_dbl(vr_y(1), vr_x(1), u_t(1), v_t(1), x_pos)
      call datacast_dbl(vi_y(1), vi_x(1), u_t(1), v_t(1), x_pos)

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"eigen_hrd_v:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"eigen_hrd_v:ui_x")
      end function

      function xx_vr_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1
      xx_vr_x = nxx_vr_x + i1 - 1
      call accessor(i0,xx_vr_x,kxx_vr_x,"eigen_hrd_v:vr_x")
      end function

      function xx_vi_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1
      xx_vi_x = nxx_vi_x + i1 - 1
      call accessor(i0,xx_vi_x,kxx_vi_x,"eigen_hrd_v:vi_x")
      end function

      function xx_vr_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_y
      integer :: i0,i1
      xx_vr_y = nxx_vr_y + i1 - 1
      call accessor(i0,xx_vr_y,kxx_vr_y,"eigen_hrd_v:vr_y")
      end function

      function xx_vi_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_y
      integer :: i0,i1
      xx_vi_y = nxx_vi_y + i1 - 1
      call accessor(i0,xx_vi_y,kxx_vi_y,"eigen_hrd_v:vi_y")
      end function

      function xx_u_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_u_t
      integer :: i0,i1
      xx_u_t = nxx_u_t + i1 - 1
      call accessor(i0,xx_u_t,kxx_u_t,"eigen_hrd_v:u_t")
      end function

      function xx_v_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_v_t
      integer :: i0,i1
      xx_v_t = nxx_v_t + i1 - 1
      call accessor(i0,xx_v_t,kxx_v_t,"eigen_hrd_v:v_t")
      end function
#endif
      end subroutine

